ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.9 by root, Tue Dec 7 20:03:15 2010 UTC vs.
Revision 1.30 by root, Fri Feb 11 02:01:24 2011 UTC

2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10MKBUNDLE="$STATICPERL/mkbundle"
11
12# perl build variables 10# perl build variables
13PERL_PREFIX="$STATICPERL/perl" # where the perl gets installed 11MAKE=make
14PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc
15PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -D_GNU_SOURCE -DNDEBUG"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-g -Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 17
19ARCH="$(uname -m)" 18ARCH="$(uname -m)"
20 19
21case "$ARCH" in 20case "$ARCH" in
22 i*86 | x86_64 | amd64 ) 21 i*86 | x86_64 | amd64 )
29 ;; 28 ;;
30esac 29esac
31 30
32# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
34# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 36
38# some configuration options for modules 37# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 38PERL_MM_USE_DEFAULT=1
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
41export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 40EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
41export PERL_MM_USE_DEFAULT CORO_INTERFACE EV_EXTRA_DEFS
42 42
43# which extra modules to install by default from CPAN that are 43# which extra modules to install by default from CPAN that are
44# required by mkbundle 44# required by mkbundle
45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
46 46
52postconfigure() { : ; } 52postconfigure() { : ; }
53postbuild() { : ; } 53postbuild() { : ; }
54postinstall() { : ; } 54postinstall() { : ; }
55 55
56# now source user config, if any 56# now source user config, if any
57if [ "$STATICPERLRC" ]; then
58 . "$STATICPERLRC"
59else
57[ -r /etc/staticperlrc ] && . /etc/staticperlrc 60 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
58[ -r ~/.staticperlrc ] && . ~/.staticperlrc 61 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
59[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 62 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
63fi
60 64
61############################################################################# 65#############################################################################
62# support 66# support
67
68MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
69PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
70
71unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
72LC_ALL=C; export LC_ALL # just to be on the safe side
63 73
64# set version in a way that Makefile.PL can extract 74# set version in a way that Makefile.PL can extract
65VERSION=VERSION; eval \ 75VERSION=VERSION; eval \
66$VERSION=0.1 76$VERSION="1.0"
67 77
68BZ2=bz2 78BZ2=bz2
69BZIP2=bzip2 79BZIP2=bzip2
70 80
71fatal() { 81fatal() {
104############################################################################# 114#############################################################################
105# clean 115# clean
106 116
107distclean() { 117distclean() {
108 verblock <<EOF 118 verblock <<EOF
109deleting everything installed by this script 119 deleting everything installed by this script (rm -rf $STATICPERL)
110EOF 120EOF
111 121
112 rm -rf "$STATICPERL" 122 rm -rf "$STATICPERL"
113} 123}
114 124
115############################################################################# 125#############################################################################
116# download/configure/compile/install perl 126# download/configure/compile/install perl
117 127
118clean() { 128clean() {
119 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 129 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
130}
131
132realclean() {
133 rm -f "$PERL_PREFIX/staticstamp.postinstall"
134 rm -f "$PERL_PREFIX/staticstamp.install"
135 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
120} 136}
121 137
122fetch() { 138fetch() {
123 rcd "$STATICPERL" 139 rcd "$STATICPERL"
124 140
136perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 152perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
137trying $URL 153trying $URL
138EOF 154EOF
139 155
140 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 156 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
157 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
141 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 158 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
142 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
143 || fatal "$URL: unable to download" 159 || fatal "$URL: unable to download"
160 rm -f perl-$PERL_VERSION.tar.$BZ2
144 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 161 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
145 fi 162 fi
146 163
147 verblock <<EOF 164 verblock <<EOF
148unpacking perl 165unpacking perl
149EOF 166EOF
150 167
151 mkdir -p unpack 168 mkdir -p unpack
169 rm -rf unpack/perl-$PERL_VERSION
152 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xC unpack \ 170 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | tar xfC - unpack \
153 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 171 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
154 chmod -R u+w unpack/perl-$PERL_VERSION 172 chmod -R u+w unpack/perl-$PERL_VERSION
155 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 173 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
156 rmdir -p unpack 174 rmdir -p unpack
157 fi 175 fi
158} 176}
159 177
160# similar to GNU-sed -i or perl -pi 178# similar to GNU-sed -i or perl -pi
161sedreplace() { 179sedreplace() {
162 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 180 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
181 rm -f "$2"
163 mv "$2~" "$2" 182 mv "$2~" "$2"
183}
184
185configure_failure() {
186 cat <<EOF
187
188
189***
190*** Configure failed - see above for the exact error message(s).
191***
192*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
193*** flags are not supported by your compiler. Less often, this is because
194*** PERL_LIBS either contains a library not available on your system (such as
195*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
196***
197*** You can provide your own flags by creating a ~/.staticperlrc file with
198*** variable assignments. For example (these are the actual values used):
199***
200
201PERL_CC="$PERL_CC"
202PERL_CCFLAGS="$PERL_CCFLAGS"
203PERL_OPTIMIZE="$PERL_OPTIMIZE"
204PERL_LDFLAGS="$PERL_LDFLAGS"
205PERL_LIBS="$PERL_LIBS"
206
207EOF
208 exit 1
164} 209}
165 210
166configure() { 211configure() {
167 fetch 212 fetch
168 213
174configuring $STATICPERL/src/perl-$PERL_VERSION 219configuring $STATICPERL/src/perl-$PERL_VERSION
175EOF 220EOF
176 221
177 rm -f "$PERL_PREFIX/staticstamp.install" 222 rm -f "$PERL_PREFIX/staticstamp.install"
178 223
179 make distclean >/dev/null 2>&1 224 "$MAKE" distclean >/dev/null 2>&1
180 225
226 sedreplace '/^#define SITELIB/d' config_h.SH
227
181 # I hate them 228 # I hate them for this
182 grep -q -- -fstack-protector Configure && \ 229 grep -q -- -fstack-protector Configure && \
183 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 230 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
184 231
185 preconfigure 232 preconfigure
186 233
190 -Dusemymalloc=n \ 237 -Dusemymalloc=n \
191 -Uusedl \ 238 -Uusedl \
192 -Uusethreads \ 239 -Uusethreads \
193 -Uuseithreads \ 240 -Uuseithreads \
194 -Uusemultiplicity \ 241 -Uusemultiplicity \
195 -Duseperlio \
196 -Uusesfio \ 242 -Uusesfio \
197 -Uuseshrplib \ 243 -Uuseshrplib \
244 -Uinstallusrbinperl \
198 -Dcppflags="$PERL_CPPFLAGS" \ 245 -A ccflags=" $PERL_CCFLAGS" \
199 -Dccflags="-g2 -fno-strict-aliasing" \ 246 -Dcc="$PERL_CC" \
200 -Doptimize="$PERL_OPTIMIZE" \ 247 -Doptimize="$PERL_OPTIMIZE" \
201 -Dldflags="$PERL_LDFLAGS" \ 248 -Dldflags="$PERL_LDFLAGS" \
202 -Dlibs="$PERL_LIBS" \ 249 -Dlibs="$PERL_LIBS" \
203 -Dprefix="$PERL_PREFIX" \ 250 -Dprefix="$PERL_PREFIX" \
204 -Dbin="$PERL_PREFIX/bin" \ 251 -Dbin="$PERL_PREFIX/bin" \
205 -Dprivlib="$PERL_PREFIX/lib" \ 252 -Dprivlib="$PERL_PREFIX/lib" \
206 -Darchlib="$PERL_PREFIX/lib" \ 253 -Darchlib="$PERL_PREFIX/lib" \
207 -Uusevendorprefix \ 254 -Uusevendorprefix \
208 -Dsitelib="$PERL_PREFIX/lib" \ 255 -Dsitelib="$PERL_PREFIX/lib" \
209 -Dsitearch="$PERL_PREFIX/lib" \ 256 -Dsitearch="$PERL_PREFIX/lib" \
210 -Usitelibexp \
211 -Uman1dir \ 257 -Uman1dir \
212 -Uman3dir \ 258 -Uman3dir \
213 -Usiteman1dir \ 259 -Usiteman1dir \
214 -Usiteman3dir \ 260 -Usiteman3dir \
215 -Dpager=/usr/bin/less \ 261 -Dpager=/usr/bin/less \
216 -Demail="$EMAIL" \ 262 -Demail="$EMAIL" \
217 -Dcf_email="$EMAIL" \ 263 -Dcf_email="$EMAIL" \
218 -Dcf_by="$EMAIL" \ 264 -Dcf_by="$EMAIL" \
265 -UDEBUGGING \
219 $PERL_CONFIGURE \ 266 $PERL_CONFIGURE \
267 -Duseperlio \
220 -dE || fatal "Configure failed" 268 -dE || configure_failure
221 269
222 sedreplace ' 270 sedreplace '
223 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 271 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
224 s/ *-fno-stack-protector */ /g 272 s/ *-fno-stack-protector */ /g
225 ' config.sh 273 ' config.sh
240building $STATICPERL/src/perl-$PERL_VERSION 288building $STATICPERL/src/perl-$PERL_VERSION
241EOF 289EOF
242 290
243 rm -f "$PERL_PREFIX/staticstamp.install" 291 rm -f "$PERL_PREFIX/staticstamp.install"
244 292
245 make || fatal "make: error while building perl" 293 "$MAKE" || fatal "make: error while building perl"
246 294
247 postbuild || fatal "postbuild hook failed" 295 postbuild || fatal "postbuild hook failed"
248} 296}
249 297
250install() { 298install() {
254 verblock <<EOF 302 verblock <<EOF
255installing $STATICPERL/src/perl-$PERL_VERSION 303installing $STATICPERL/src/perl-$PERL_VERSION
256to $PERL_PREFIX 304to $PERL_PREFIX
257EOF 305EOF
258 306
259 rm -rf "$PERL_PREFIX" 307 ln -sf "perl/bin/" "$STATICPERL/bin"
260 308 ln -sf "perl/lib/" "$STATICPERL/lib"
309
310 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
311 rm -rf "$PERL_PREFIX" # by this rm -rf
312
261 make install || fatal "make install: error while installing" 313 "$MAKE" install || fatal "make install: error while installing"
262 314
263 rcd "$PERL_PREFIX" 315 rcd "$PERL_PREFIX"
264 316
265 # create a "make install" replacement for CPAN 317 # create a "make install" replacement for CPAN
266 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 318 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
267make install UNINST=1 319"$MAKE" || exit
320
268if find blib/arch/auto -type f | grep -q -v .exists; then 321if find blib/arch/auto -type f | grep -q -v .exists; then
269 echo Probably an XS module, rebuilding perl 322 echo Probably an XS module, rebuilding perl
270 make perl 323 if "$MAKE" perl; then
324 mv perl "$PERL_PREFIX"/bin/perl~ \
271 rm -f "$PERL_PREFIX"/bin/perl 325 && rm -f "$PERL_PREFIX"/bin/perl \
272 make -f Makefile.aperl inst_perl 326 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
273 make -f Makefile.aperl map_clean 327 "$MAKE" -f Makefile.aperl map_clean
328 else
329 "$MAKE" -f Makefile.aperl map_clean
330 exit 1
331 fi
274fi 332fi
333
334"$MAKE" install UNINST=1
275EOF 335EOF
276 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 336 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
277 337
278 # trick CPAN into avoiding ~/.cpan completely 338 # trick CPAN into avoiding ~/.cpan completely
279 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 339 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
294 ' || fatal "error while initialising CPAN" 354 ' || fatal "error while initialising CPAN"
295 355
296 touch "$PERL_PREFIX/staticstamp.install" 356 touch "$PERL_PREFIX/staticstamp.install"
297 fi 357 fi
298 358
299 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall"; then 359 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
300 NOCHECK_INSTALL=+ 360 NOCHECK_INSTALL=+
301 instcpan $STATICPERL_MODULES 361 instcpan $STATICPERL_MODULES
302 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 362 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
303 363
304 postinstall || fatal "postinstall hook failed" 364 postinstall || fatal "postinstall hook failed"
339 for mod in "$@"; do 399 for mod in "$@"; do
340 echo 400 echo
341 echo $mod 401 echo $mod
342 ( 402 (
343 rcd $mod 403 rcd $mod
344 make -f Makefile.aperl map_clean >/dev/null 2>&1 404 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
345 make distclean >/dev/null 2>&1 405 "$MAKE" distclean >/dev/null 2>&1
346 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 406 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
347 make || fatal "$mod: error building module" 407 "$MAKE" || fatal "$mod: error building module"
348 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 408 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
349 make distclean >/dev/null 2>&1 409 "$MAKE" distclean >/dev/null 2>&1
350 exit 0 410 exit 0
351 ) || exit $? 411 ) || exit $?
352 done 412 done
353} 413}
354 414
355############################################################################# 415#############################################################################
356# main 416# main
357 417
358podusage() { 418podusage() {
359 echo 419 echo
420
360 if [ -e "$PERL_PREFIX/bin/perl" ]; then 421 if [ -e "$PERL_PREFIX/bin/perl" ]; then
361 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 422 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
362 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 423 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
363 2>/dev/null && exit 424 2>/dev/null && exit
364 fi 425 fi
426
365 # try whatever perl we can find 427 # try whatever perl we can find
366 perl -MPod::Usage -e \ 428 perl -MPod::Usage -e \
367 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 429 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
368 2>/dev/null && exit 430 2>/dev/null && exit
369 431
370 fatal "displaying documentation requires a working perl - try '$0 install' first" 432 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
371} 433}
372 434
373usage() { 435usage() {
374 podusage 0 436 podusage 0
375} 437}
385} 447}
386 448
387bundle() { 449bundle() {
388 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 450 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
389 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 451 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
452 CACHE="$STATICPERL/cache"
453 mkdir -p "$CACHE"
390 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 454 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
391} 455}
392 456
393if [ $# -gt 0 ]; then 457if [ $# -gt 0 ]; then
394 while [ $# -gt 0 ]; do 458 while [ $# -gt 0 ]; do
395 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 459 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
396 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create" 460 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
397 461
398 command="${1#--}"; shift 462 command="${1#--}"; shift
399 case "$command" in 463 case "$command" in
464 version )
465 echo "staticperl version $VERSION"
466 ;;
400 fetch | configure | build | install | clean | distclean) 467 fetch | configure | build | install | clean | realclean | distclean)
401 verblock <<EOF
402$command
403EOF
404 ( "$command" ) 468 ( "$command" ) || exit
405 ;; 469 ;;
406 instsrc ) 470 instsrc )
407 ( instsrc "$@" ) 471 ( instsrc "$@" ) || exit
408 exit 472 exit
409 ;; 473 ;;
410 instcpan ) 474 instcpan )
411 ( instcpan "$@" ) 475 ( instcpan "$@" ) || exit
412 exit 476 exit
413 ;; 477 ;;
414 cpan ) 478 cpan )
415 ( install ) 479 ( install ) || exit
416 "$PERL_PREFIX/bin/cpan" "$@" 480 "$PERL_PREFIX/bin/cpan" "$@"
417 exit 481 exit
418 ;; 482 ;;
419 mkbundle ) 483 mkbundle )
420 ( install ) 484 ( install ) || exit
421 bundle "$@" 485 bundle "$@"
422 exit 486 exit
423 ;; 487 ;;
424 mkperl ) 488 mkperl )
425 ( install ) 489 ( install ) || exit
426 bundle --perl "$@" 490 bundle --perl "$@"
491 exit
492 ;;
493 mkapp )
494 ( install ) || exit
495 bundle --app "$@"
427 exit 496 exit
428 ;; 497 ;;
429 help ) 498 help )
430 podusage 2 499 podusage 2
431 ;; 500 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines